// ************************************************************************************************
// 01.11.07
// sw_071101_02
// -- test, warum adc12 UND uhrzeit nicht geht...
// ************************************************************************************************

#include "owndef.h"
#include "RTC_Calendar.h"
#include "RTC_TA.h"
// ************************************************************************************************
// funktionsprototypen
// ************************************************************************************************
void wait(WORD i);
void port_def(void);
// ************************************************************************************************
// ************************************************************************************************
// definition globaler variablen
// ************************************************************************************************
static BYTE Tick = 0;
// ************************************************************************************************
// ************************************************************************************************
// HAUPTPROGRAMM
// ************************************************************************************************
void main()
{
  WDTCTL=WDTPW+WDTHOLD;                             // stoppt den WDT
  port_def();                                       // fr definition der ports  
// ************************************************************************************************
// ntige sachen fr den ADC12
// ************************************************************************************************
  ADC12CTL0 = ADC12ON+SHT0_2+REFON+REF2_5V;         // ADC12ON --> schaltet ad-wandler ein
                                                    // SHT0_2  --> clocks fr sample-time
                                                    // REFON   --> interne referenz an
                                                    // REF2_5  --> referenz auf 2.5V
  ADC12CTL1 = SHP;                                  // Use sampling timer
  wait(3600);                                       // wartezeit, damit referenzspannung steht...
// ************************************************************************************************
// ************************************************************************************************
// timer A einstellen
// ************************************************************************************************
  CCTL0 = CCIE;                                     // CCR0 interrupt enabled
  CCR0  = ZEITBASIS;			            // Wert in owndef, Zhl-Zeit bis Interrupt
  TACTL = TASSEL0 + MC0;                            // ACLK, upmode
  _EINT();
// ************************************************************************************************
// ************************************************************************************************
// einstellen und starten der uhrzeit
// ************************************************************************************************
  TI_dayLightZone = EU_DAYLIGHT_SAVINGS;            // setzt variable fr eu-sommerzeitumstellung
  setDate(2007, 9, 5);                              // inititialiesieren des datums auf 01.01.2007
  setTime(0x01, 0x00, 0x00, 0);                     // inititialisieren der zeit auf 01:00:00 AM
  TA_1sec_wake();                                   // configure TA for 1 second update
  //LPM3;                                             // enter LPM3, clock will be updated
  //get_date_and_time();                              // erstmaliges holen des datums und der uhrzeit
// ************************************************************************************************
  for (;;)                                          // beginn endlosschleife for(;;)
  {
    _NOP();
  } // ende endlosschleife for (;;)
}   // ende main
// ************************************************************************************************
// ************************************************************************************************
// funktion fr eine warteschleife
// ************************************************************************************************
void wait(WORD i)
{
  WORD j;
  _NOP();                                           // einen Taktzyklus warten
  for(j=0;j<i;j++);
}
// ************************************************************************************************
// funktion, um die einzelnen pins der ports einzustellen (auf ein-, oder ausgang, high oder low)
// ************************************************************************************************
void port_def(void)
{
// port1 einstellen                                 // port fr lcd
  P1DIR = 0xFF;                                     // alle pins auf ausgang setzen
  P1OUT = 0x00;                                     // alle pins auf null setzen
// port2 einstellen
  P2DIR = 0x7F;                                     // alle pins auf ausgang, bis auf P2.7
  P2OUT = 0x00;                                     // alle pins auf null setzen
// port3 einstellen                                 // port fr taster
  P3DIR = 0x00;                                     // alle pins von port3 auf eingang setzen
  P3OUT = 0x00;                                     // alle pins von port3 auf null setzen
  P3DIR = PEAK_RESET;                               // peak_reset auf ausgang
// port4 einstellen
  P4DIR = 0xFE;                                     // alle pins auf ausgang setzen, bis auf P4.0
                                                    // = 1111 1110 = 0xFE
  P4OUT = 0x00;                                     // alle pins auf null setzen
// port5 einstellen                                 // port fr sd-card
  P5DIR = 0x80;                                     // alle pins auf eingang setzen, bis auf P5.7
                                                    // = 1000 0000 = 0x80
  P5OUT = 0x00;                                     // alle pins auf null setzen
// port6 einstellen
  P6SEL |= 0x03;                                    // Enable A/D channel A0 und A1; P6.0 & P6.1
}
// ************************************************************************************************
//*************************************************************************************************
// interrupt routinen
//*************************************************************************************************
// Timer A0 interrupt service routine
#pragma vector=TIMERA0_VECTOR
__interrupt void Timer_A (void)
{
  /*
  #define ZEITBASIS (32768/8)
  --> steht in owndef.h drin!
  --> alle 125ms ein tick
  */  
  if (Tick == (32768 / ZEITBASIS)) Tick = 0;        // timer zurcksetzen
  else Tick++;
}
//*************************************************************************************************
