#ifndef OWNDEF_H
#define OWNDEF_H

#define MCUTYPE 1612                                // mcu-typ

#if     MCUTYPE == 1612
 #include <msp430x16x.h>
#endif

// Prprozessor-Anweisungen
#define VERSION "0.1"
#define BitLoeschen(Port, Bit)   P ## Port ## OUT &= ~(Bit)
#define BitSetzen(Port, Bit)     P ## Port ## OUT |= (Bit)
#define BitToggeln(Port, Bit)    P ## Port ## OUT ^= (Bit)

//eigene datentypen
#define BYTE unsigned char                          // 8-Bit
#define WORD unsigned short                         // 16-Bit
#define DWORD unsigned long                         // 32-Bit
#define QWORD unsigned long long                    // 64-bit

// LCD (port2)
#define E               0x10                        // P 2.4 - Enable Signal fr LC-Display
#define RS              0x20                        // P 2.5 - RS des LCD

//*****************************
// meine eigenen defines
//*****************************
// port2
// leds
#define LED_SD       0x01                           // P2.0
#define LED_LINE     0x02                           // P2.1
#define LED_MIC      0x04                           // P2.2
#define LED_UEBER95  0x08                           // P2.3
#define LED_UEBER99  0x40                           // P2.6

// port3
// taster, peak-reset, spi
#define PEAK_RESET  0x01                            // peak-schaltkreis zurcksetzten
#define UP          0x10                            // P3.4 taster up
#define LEFT        0x20                            // P3.5 taster left
#define SET         0x40                            // P3.6 taster set
#define RIGHT       0x80                            // P3.7 taster right

// port4
// taster, steuersignale
#define DOWN    0x01                                // P4.0 taster down
//#define PGA     xxxx                              // P4.x taster PGA

#define STSIG_1  0x02                               //P4.1 
#define STSIG_2  0x04                               //P4.2
#define STSIG_3  0x08                               //P4.3 
#define STSIG_4  0x10                               //P4.4 
#define STSIG_5  0x20                               //P4.5

// port5
// statuspins fr sd-card
#define SW1     0x80                                // P5.7
#define SW3     0x20                                // P5.5
#define SW2     0x40                                // P5.6


// port6
// adc12

#define MINIMALLAUTSTAERKE  70                      // minimaler wert fr pegel (--> 70dB)
#define MAXIMALLAUTSTAERKE 130                      // maximaler wert fr pegel (--> 130dB)

#define MAXIMALKORREKTUR    30                      // max. einstellbarer korrekturwert (--> 30dB)

#define ENTPRELLZAHL        7                       // schleifendurchlufe fr tastenentprellung

#define ZEITBASIS          (32768/8)                // tick-zhler bis zum nchsten messwert

// sonderezciehn frs display
#define PFEILRECHTS  126                            // sonderzeichen pfeil nach rechts     
#define PFEILLINKS   127                            // sonderzeichen pfeil nach links
#define BUCHSTABE_AE 225                            // sonderzeichen 
#define BUCHSTABE_OE 239                            // sonderzeichen 
#define BUCHSTABE_UE 245                            // sonderzeichen 

//#define WANDLERWERT_EFF_O   3695
//#define WANDLERWERT_EFF_U   176
//#define WANLDERWERT_PEAK_O  3950
//#define WANDLERWERT_PEAK_U  210
//#define EFF_ANSTIEG         0.0185
//#define EFF_Y_SCHNITT       66.75
//#define PEAK_ANSTIEG        0.0174
//#define PEAK_Y_SCHNITT      66.35

#endif
